////////////////////////////////////////////////////////////////////////////////
// Copyright (c) Elektrobit Automotive GmbH
// Alle Rechte vorbehalten. All Rights Reserved.
//
// Information contained herein is subject to change without notice.
// Elektrobit retains ownership and all other rights in the software and each
// component thereof.
// Any reproduction of the software or components thereof without the prior
// written permission of Elektrobit is prohibited.
////////////////////////////////////////////////////////////////////////////////

#ifndef GTF_TEMPERATURECONVERTER_H
#define GTF_TEMPERATURECONVERTER_H

namespace dependencyResolving
{

    class TemperatureConverter : public gtf::dependencyresolver::Interface
    {
    public:
        virtual float convertToFahrenheit(float value) = 0;

        virtual float convertToKelvin(float value ) = 0;
    };

typedef gtf::smartptr::RefCountedPtr<TemperatureConverter> TemperatureConverterHandle;

}
GTF_DEFINE_INTERFACE_NAME(dependencyResolving::TemperatureConverter);
#endif // GTF_TEMPERATURECONVERTER_H

