////////////////////////////////////////////////////////////////////////////////
// Copyright (c) Elektrobit Automotive GmbH
// Alle Rechte vorbehalten. All Rights Reserved.
//
// Information contained herein is subject to change without notice.
// Elektrobit retains ownership and all other rights in the software and each
// component thereof.
// Any reproduction of the software or components thereof without the prior
// written permission of Elektrobit is prohibited.
////////////////////////////////////////////////////////////////////////////////
#include "TemperatureConverterImpl.h"

using namespace gtf;

dependencyResolving::TemperatureConverterImpl::TemperatureConverterImpl(diagnostic::LogHandle & logger_)
:logger(logger_)
{

}
float dependencyResolving::TemperatureConverterImpl::convertToFahrenheit(float value)
{
    float result = value * 9 / 5 + 32;

    logger->print(diagnostic::Log::LogInfo, "Conversion to Fahrenheit from  Celsius: %f C -> %f F", value, result);

    return result;
}

float dependencyResolving::TemperatureConverterImpl::convertToKelvin(float value)
{
    float result = value + (float)273.15;

    logger->print(diagnostic::Log::LogInfo, "Conversion to Kelvin from  Celsius: %f C -> %f K", value, result);

    return result;
}
