////////////////////////////////////////////////////////////////////////////////
// Copyright (c) Elektrobit Automotive GmbH
// Alle Rechte vorbehalten. All Rights Reserved.
//
// Information contained herein is subject to change without notice.
// Elektrobit retains ownership and all other rights in the software and each
// component thereof.
// Any reproduction of the software or components thereof without the prior
// written permission of Elektrobit is prohibited.
////////////////////////////////////////////////////////////////////////////////

#ifndef GTF_TEMPERATURECONVERTER_IMPL_H
#define GTF_TEMPERATURECONVERTER_IMPL_H

#include <gtf/dependencyresolver/DependencyContainer.h>
#include "TemperatureConverter.h"
#include <gtf/diagnostic/Log.h>

namespace dependencyResolving
{
    class TemperatureConverterImpl : public TemperatureConverter
    {
    public:
        TemperatureConverterImpl(gtf::diagnostic::LogHandle & logger_);

        virtual float convertToFahrenheit(float value);

        virtual float convertToKelvin(float value);

    private:
        gtf::diagnostic::LogHandle logger;

    };

    typedef gtf::smartptr::RefCountedPtr<TemperatureConverterImpl> TemperatureConverterImplHandle;

}

#endif // GTF_TEMPERATURECONVERTER_IMPL_H

