////////////////////////////////////////////////////////////////////////////////
// Copyright (c) Elektrobit Automotive GmbH
// Alle Rechte vorbehalten. All Rights Reserved.
//
// Information contained herein is subject to change without notice.
// Elektrobit retains ownership and all other rights in the software and each
// component thereof.
// Any reproduction of the software or components thereof without the prior
// written permission of Elektrobit is prohibited.
////////////////////////////////////////////////////////////////////////////////

#ifndef GTF_DATAEVENTAPP_H_INCLUDED
#define GTF_DATAEVENTAPP_H_INCLUDED

#include <gtf/dependencyresolver/DependencyContainer.h>
#include <gtf/launcher/Runnable.h>
#include <gtf/osal/MainTaskDispatcher.h>
#include <gtf/osal/DelegateTask.h>
#include <gtf/eventsystem/EventQueue.h>

namespace eventplugin
{
    class EventApplication : public gtf::launcher::Runnable
    {
    public:
        EventApplication(gtf::osal::MainTaskDispatcherHandle & taskDispatcher_, gtf::eventsystem::global::EventQueueHandle & eventQueue_);

        virtual void run();
        virtual void stop();

    private:
        void processEvent(gtf::eventsystem::global::EventHandle);
        void invoker();

        gtf::dependencyresolver::DependencyContainerHandle container;
        gtf::osal::MainTaskDispatcherHandle taskDispatcher;
        gtf::eventsystem::global::EventQueueHandle eventQueue;
        gtf::osal::DelegateTask processEventTask;

    };

}

#endif // GTF_DATAEVENTAPP_H_INCLUDED

