////////////////////////////////////////////////////////////////////////////////
// Copyright (c) Elektrobit Automotive GmbH
// Alle Rechte vorbehalten. All Rights Reserved.
//
// Information contained herein is subject to change without notice.
// Elektrobit retains ownership and all other rights in the software and each
// component thereof.
// Any reproduction of the software or components thereof without the prior
// written permission of Elektrobit is prohibited.
////////////////////////////////////////////////////////////////////////////////

#ifndef SCRIPT_FUNCTIONS_WIDGETDESC_PROVIDER_H_INCLUDED
#define SCRIPT_FUNCTIONS_WIDGETDESC_PROVIDER_H_INCLUDED

#include <gtf/metainfo/DescriptorProvider.h>

/*!
\brief DescriptorProvider for the widget set template
*/
class ScriptFunctionDescProvider : public gtf::metainfo::DescriptorProvider
{
public:
    virtual gtf::metainfo::ActionDescriptor const* GetActions(uint32_t &count) const;
    virtual gtf::metainfo::PopupStackDescriptor const* GetPopupStacks(uint32_t &count) const
    {
        count = 0;
        return NULL;
    }
    virtual gtf::metainfo::MediatorDescriptor const* GetMediators(uint32_t &count) const
    {
        count = 0;
        return NULL;
    }
    virtual gtf::metainfo::WidgetDescriptor const* GetWidgets(uint32_t &count) const
    {
        count = 0;
        return NULL;
    }
    virtual gtf::metainfo::WidgetFeatureDescriptor const* GetWidgetFeatures(uint32_t &count) const
    {
        count = 0;
        return NULL;
    }
    virtual gtf::metainfo::ResourceDescriptor const* GetResourceTypes(uint32_t &count) const
    {
        count = 0;
        return NULL;
    }
    virtual bool ResolveTypes(const gtf::type::TypeManager* typeManager);
};

#endif // SCRIPT_FUNCTIONS_WIDGETDESC_PROVIDER_H_INCLUDED
