////////////////////////////////////////////////////////////////////////////////
// Copyright (c) Elektrobit Automotive GmbH
// Alle Rechte vorbehalten. All Rights Reserved.
//
// Information contained herein is subject to change without notice.
// Elektrobit retains ownership and all other rights in the software and each
// component thereof.
// Any reproduction of the software or components thereof without the prior
// written permission of Elektrobit is prohibited.
////////////////////////////////////////////////////////////////////////////////
#include "SettingsApplication.h"
#include <gtf/configuration/ListValue.h>
#include <gtf/configuration/Settings.h>

settingsplugin::SettingsApplication::SettingsApplication(gtf::dependencyresolver::DependencyContainerHandle& container_, gtf::diagnostic::LogHandle & logger_)
: container(container_)
, logger(logger_)
{

}

void settingsplugin::SettingsApplication::run()
{
    gtf::configuration::SettingsHandle settings = container->get<gtf::configuration::Settings>();

    if (!settings.valid())
    {
        return;
    }

    gtf::configuration::StringListHandle plugins = settings->getItem<gtf::configuration::StringList>("gtf.core.pluginstoload");

    if (plugins.valid())
    {
        for (uint32_t i = 0; i < plugins->getSize(); i++)
        {
            logger->print(gtf::diagnostic::Log::LogInfo, plugins->getElement(i));
        }
    }
}

void settingsplugin::SettingsApplication::stop()
{
}

