////////////////////////////////////////////////////////////////////////////////
// Copyright (c) Elektrobit Automotive GmbH
// Alle Rechte vorbehalten. All Rights Reserved.
//
// Information contained herein is subject to change without notice.
// Elektrobit retains ownership and all other rights in the software and each
// component thereof.
// Any reproduction of the software or components thereof without the prior
// written permission of Elektrobit is prohibited.
////////////////////////////////////////////////////////////////////////////////

#ifndef GTF_EARLY_STAGE_IMPL_H_INCLUDED
#define GTF_EARLY_STAGE_IMPL_H_INCLUDED

#include <gtf/model/Stage.h>
#include <gtf/dependencyresolver/DependencyContainer.h>
#include <gtf/diagnostic/Log.h>

namespace stageplugin
{
    class EarlyStage : public gtf::model::Stage
    {
    public:
        EarlyStage(gtf::dependencyresolver::DependencyContainerHandle & container_);
        ~EarlyStage();

    private:
        gtf::dependencyresolver::DependencyContainerHandle container;
        gtf::diagnostic::LogHandle logger;
    };

}

GTF_DEFINE_INTERFACE_NAME(stageplugin::EarlyStage);
#endif // GTF_EARLY_STAGE_IMPL_H_INCLUDED

