////////////////////////////////////////////////////////////////////////////////
// Copyright (c) Elektrobit Automotive GmbH
// Alle Rechte vorbehalten. All Rights Reserved.
//
// Information contained herein is subject to change without notice.
// Elektrobit retains ownership and all other rights in the software and each
// component thereof.
// Any reproduction of the software or components thereof without the prior
// written permission of Elektrobit is prohibited.
////////////////////////////////////////////////////////////////////////////////
#include "PreparedStageImpl.h"

stageplugin::PreparedStageImpl::PreparedStageImpl(gtf::dependencyresolver::DependencyContainerHandle & container_)
:container(container_)
, logger(container->get<gtf::diagnostic::Log>())
{
    if (logger.valid())
    {
        logger->print(gtf::diagnostic::Log::LogInfo, " %s stage has been loaded", gtf::dependencyresolver::InterfaceName<gtf::model::PreparedStage>::name());
    }
}

stageplugin::PreparedStageImpl::~PreparedStageImpl()
{
    if (logger.valid())
    {
        logger->print(gtf::diagnostic::Log::LogInfo, " %s stage has been unloaded", gtf::dependencyresolver::InterfaceName<gtf::model::PreparedStage>::name());
    }
}

