////////////////////////////////////////////////////////////////////////////////
// Copyright (c) Elektrobit Automotive GmbH
// Alle Rechte vorbehalten. All Rights Reserved.
//
// Information contained herein is subject to change without notice.
// Elektrobit retains ownership and all other rights in the software and each
// component thereof.
// Any reproduction of the software or components thereof without the prior
// written permission of Elektrobit is prohibited.
////////////////////////////////////////////////////////////////////////////////

#ifndef GTF_WINDOWLIST_H_INCLUDED
#define GTF_WINDOWLIST_H_INCLUDED

#include <gtf/dependencyresolver/DependencyContainer.h>
#include <gtf/launcher/Runnable.h>
#include <gtf/osal/MainTaskDispatcher.h>
#include <gtf/osal/DelegateTask.h>
#include <gtf/datapool/Datapool.h>
#include <gtf/datapool/ListValue.h>
#include <gtf/configuration/PathValue.h>

namespace windowlistplugin
{
    class WindowListApplication : public gtf::launcher::Runnable
    {
    public:
        WindowListApplication(gtf::dependencyresolver::DependencyContainerHandle & container_, gtf::osal::MainTaskDispatcherHandle & taskDispatcher_, gtf::datapool::DatapoolHandle & datapool_);
        virtual void run();
        virtual void stop();

    private:
        void initializeDatapool();
        gtf::configuration::PathValueHandle getDatapoolDescription();
        void readAllDatapoolItems();
        void processDatapoolItems();
        void invoker();
        void updateWindowList();

        gtf::dependencyresolver::DependencyContainerHandle container;
        gtf::datapool::DatapoolHandle datapool;
        gtf::osal::MainTaskDispatcherHandle taskDispatcher;
        gtf::osal::DelegateTask processDatapoolTask;
    };

}

#endif // GTF_WINDOWLIST_H_INCLUDED

